package class9_Lab_Command_031_start;

import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.scene.control.Alert;
import javafx.scene.control.Button;
import javafx.scene.layout.GridPane;
import javafx.util.Pair;

import java.util.ArrayList;
import java.util.List;

public class Controller {
    private static final int GRID_SIZE = 3;
    @FXML
    private GridPane grid;

    private List<Button> buttons = new ArrayList<>();

    private Pair<Integer,Integer> coordinate;

    private char whoseTurn = 'X';

    /**
     * Add buttons to GridPane
     */
    public void initialize() {
        for(int y = 0; y < GRID_SIZE; y++) {
            for(int x = 0; x < GRID_SIZE; x++) {
                Button b = new Button();
                b.setUserData(new Pair<>(x,y));
                b.setOnAction(this::move);
                b.setPrefSize(30,30);
                grid.add(b,x,y);
                buttons.add(b);
            }
        }
    }

    @FXML
    public void undo(ActionEvent actionEvent) {
        //TODO: Implement this button.
    }

    /**
     * Event handler for the buttons
     * @param actionEvent
     */
    private void move(ActionEvent actionEvent) {
        Button button = ((Button) actionEvent.getSource());
        Pair<Integer, Integer> coordinates =
                (Pair<Integer, Integer>) button.getUserData();
        int x = coordinates.getKey();
        int y = coordinates.getValue();

        if (button.getText().isEmpty()) {
            button.setText(""+whoseTurn);
            boolean isWin = false;
            isWin |= checkRow(y);
            isWin |= checkColumn(x);
//            isWin |= checkDiagonals(x, y); Not yet implemented... and not part of quiz!
            if(isWin) {
                Alert alert = new Alert(Alert.AlertType.INFORMATION);
                alert.setHeaderText("Player "+whoseTurn+" has won!");
                alert.showAndWait();
            }
            updateTurn();
        } else {
            System.out.println("Warning: Attempt to play at occupied place: "+x+","+y);
        }
    }

    private void updateTurn() {
        whoseTurn = otherTurn();
    }

    private char otherTurn() {
        switch(whoseTurn) {
            case 'X': return 'O';
            case 'O': return 'X';
            default:
                throw new IllegalStateException("The turn must always be O or X. it is: "+ whoseTurn);
        }
    }

    /**
     * @param checkY row index to check
     * @return true if whoseTurn fills whole row
     */
    private boolean checkRow(int checkY) {
        int gridX = 0;
        while(gridX < GRID_SIZE
                && getButton(gridX,checkY).getText().equals(""+whoseTurn)) {
            gridX++;
        }
        return gridX == GRID_SIZE;
    }

    /**
     * @param checkX row index to check
     * @return true if whoseTurn fills whole row
     */
    private boolean checkColumn(int checkX) {
        int gridY = 0;
        while(gridY < GRID_SIZE
                && getButton(checkX,gridY).getText().equals(""+whoseTurn)) {
            gridY++;
        }
        return gridY == GRID_SIZE;
    }

    public Button getButton(int x, int y) {
        return buttons.get(y*GRID_SIZE+x);
    }

}
